/* GCC */

#define maxN 1000 //    n

#include <stdio.h>

bool a[maxN + 2][maxN + 2]; //          
                            // (     ).
                            // a[i][j] == true ,   
int main()
{
    freopen("squares.in", "r", stdin);
    freopen("squares.out", "w", stdout);

    int n;
    scanf("%d\n", &n);

    //      :
    for (int i = 0; i < n + 2; i++)
        a[0][i] = a[i][0] = a[n + 1][i] = a[i][n + 1] = false;

    //   :
    for (int y = 1; y <= n; y++) //     y,    x
        for (int x = 1; x <= n; x++)
        {
            char c;
            scanf(x < n ? "%c " : "%c\n", &c); //     
                                               //     
            a[x][y] = (c == '#'); //  ,     #
        }

    //    ,      :
    int s1_left = 0, s1_top = 0; //         
                                 // (   ).  
                                 // ,      
    for (int x = 1; x <= n; x++) //   :
    {
        for (int y = 1; y <= n; y++) //   :
            if (a[x][y] && ! a[x - 1][y] && ! a[x][y - 1])
            {   //      , 
                //     :
                s1_left = x;
                s1_top = y;
                break;
            }
        if (s1_left > 0) //   ,      
            break;
    }

    //           :
    int s1_right = s1_left, s1_bottom = s1_top; //       
                                                //   ( 
                                                //  )
    while (a[s1_right + 1][s1_top] && a[s1_left][s1_bottom + 1])
    {   //   ,    ,   :
        s1_right++;
        s1_bottom++;
    }

    // ,          :
    bool internal = false; //    
    bool external = false; //    
    for (int x = 1; x <= n; x++) //     :
        for (int y = 1; y <= n; y++)
            if (a[x][y]) //   :
            {
                if (x > s1_left && x < s1_right && y > s1_top && y < s1_bottom)
                    internal = true; //     
                else if (x < s1_left || x > s1_right || y < s1_top || y > s1_bottom)
                    external = true; //     
            }

    int s2_left, s2_top, s2_right, s2_bottom; //    , ,  
                                              //     (
                                              //     )
    if (external) //       :
    {
        for (int x = 1; x <= n; x++)
        {
            bool found = false; //    ,    
                                // ,     ,  ,
                                //    
            for (int y = 1; y <= n; y++)
                if (a[x][y] && (x < s1_left || x > s1_right || y < s1_top || y > s1_bottom))
                {   //          :
                    bool isTopLeft = ! a[x - 1][y] && ! a[x][y - 1]; //      
                    bool isBottomRight = ! a[x + 1][y] && ! a[x][y + 1]; //      
                    //     ,        ,
                    //               
                    //      ,    

                    if (isTopLeft || isBottomRight)
                    {
                        //    :
                        s2_left = s2_right = x;
                        s2_top = s2_bottom = y;

                        found = true;
                    }

                    //     ,    
                    // (  )   ,     
                    // .      :
                    if (isTopLeft)
                        while (x < s1_left ? a[s2_left][s2_bottom + 1] : a[s2_right + 1][s2_top])
                        {
                            s2_right++;
                            s2_bottom++;
                        }
                    else if (isBottomRight)
                        while (x > s1_right ? a[s2_right][s2_top - 1] : a[s2_left - 1][s2_bottom])
                        {
                            s2_left--;
                            s2_top--;
                        }

                    if (found) //     ,   
                        break;
                }
            if (found) //    ,     
                break;
        }
    }
    else if (internal) //        ,
    {                  //       :
        //  , ,      ,
        //      :
        s2_left = s1_right; //  
        s2_top = s1_bottom;
        s2_right = s1_left;
        s2_bottom = s1_top;
        for (int x = s1_left + 1; x <= s1_right - 1; x++) //    
            for (int y = s1_top + 1; y <= s1_bottom - 1; y++) //  :
                if (a[x][y])
                {   //   ,  :
                    if (x < s2_left)
                        s2_left = x;
                    if (y < s2_top)
                        s2_top = y;
                    if (x > s2_right)
                        s2_right = x;
                    if (y > s2_bottom)
                        s2_bottom = y;
                }

        //        ,   
        //       ,    :
        if (s2_top == s1_top + 1) //       :
        {
            s2_top = s1_top; // ³  ,  , , :
            for (int x = s1_left + 1; x < s1_right - 1; x++)
                if (a[x][s1_top + 1] && a[x + 1][s1_top + 1])
                {   //      ,  :
                    s2_top = s1_top + 1;
                    break;
                }
        }

        //    :
        if (s2_bottom == s1_bottom - 1)
        {
            s2_bottom = s1_bottom;
            for (int x = s1_left + 1; x < s1_right - 1; x++)
                if (a[x][s1_bottom - 1] && a[x + 1][s1_bottom - 1])
                {
                    s2_bottom = s1_bottom - 1;
                    break;
                }
        }

        //    :
        if (s2_left == s1_left + 1)
        {
            s2_left = s1_left;
            for (int y = s1_top + 1; y < s1_bottom - 1; y++)
                if (a[s1_left + 1][y] && a[s1_left + 1][y + 1])
                {
                    s2_left = s1_left + 1;
                    break;
                }
        }

        //    :
        if (s2_right == s1_right - 1)
        {
            s2_right = s1_right;
            for (int y = s1_top + 1; y < s1_bottom - 1; y++)
                if (a[s1_right - 1][y] && a[s1_right - 1][y + 1])
                {
                    s2_right = s1_right - 1;
                    break;
                }
        }
    } else //         :
    {
        //      :
        s2_left = s1_left;
        s2_top = s1_top;
        s2_right = s1_right;
        s2_bottom = s1_bottom;
    }

    int o[2][4] = { //  ,      
        {s1_left, s1_top, s1_right, s1_bottom},
        {s2_left, s2_top, s2_right, s2_bottom}
    };

    bool directOrder = true; //      (true)
                             //    (false)
    // ,       :
    for (int i = 0; i < 4; i++)
        if (o[0][i] > o[1][i]) //      
        {
            directOrder = false;
            break;
        } else if (o[0][i] < o[1][i]) //      
            break;

    for (int row = 0; row < 2; row++) //  
        for (int i = 0; i < 4; i++) //    
            //          :
            printf(i < 3 ? "%d " : "%d\n", o[directOrder ? row : 1 - row][i]);

    return 0;
}
